/* A Bison parser, made by GNU Bison 3.7.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2020 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30704

/* Bison version string.  */
#define YYBISON_VERSION "3.7.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 1 "./parser.y"

/* This file is part of the Project Athena Zephyr Notification System.
 * It is one of the source files comprising zwgc, the Zephyr WindowGram
 * client.
 *
 *      Created by:     Marc Horowitz <marc@athena.mit.edu>
 *
 *      $Id: 30f4088d5ca5f679e328f7a84d64b968ac5a42fa $
 *
 *      Copyright (c) 1989 by the Massachusetts Institute of Technology.
 *      For copying and distribution information, see the file
 *      "mit-copyright.h".
 */

#include <sysdep.h>

#if (!defined(lint) && !defined(SABER))
static const char rcsid_parser_y[] = "$Id: 30f4088d5ca5f679e328f7a84d64b968ac5a42fa $";
#endif

#include <zephyr/mit-copyright.h>

/* Saber-C suppressions because yacc loses */

/*SUPPRESS 288*/
/*SUPPRESS 287*/

#include <stdio.h>
#include "lexer.h"
#include "parser.h"
#include "node.h"
#include "zwgc.h"

static void yyerror(char *);

/*
 * the_program - local variable used to communicate the program's node
 *               representation from the program action to the parse_file
 *               function.
 */

static Node *the_program;

#line 115 "y.tab.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

/* Use api.header.include to #include this header
   instead of duplicating it here.  */
#ifndef YY_YY_Y_TAB_H_INCLUDED
# define YY_YY_Y_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token kinds.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    YYEMPTY = -2,
    YYEOF = 0,                     /* "end of file"  */
    YYerror = 256,                 /* error  */
    YYUNDEF = 257,                 /* "invalid token"  */
    ERROR = 258,                   /* ERROR  */
    VARNAME = 259,                 /* VARNAME  */
    VARREF = 260,                  /* VARREF  */
    STRING = 261,                  /* STRING  */
    SHOW = 262,                    /* SHOW  */
    APPENDPORT = 263,              /* APPENDPORT  */
    BUFFER = 264,                  /* BUFFER  */
    BREAK = 265,                   /* BREAK  */
    CLOSEINPUT = 266,              /* CLOSEINPUT  */
    CLOSEOUTPUT = 267,             /* CLOSEOUTPUT  */
    CLOSEPORT = 268,               /* CLOSEPORT  */
    CASE = 269,                    /* CASE  */
    CLEARBUF = 270,                /* CLEARBUF  */
    DEFAULT = 271,                 /* DEFAULT  */
    DISPLAY = 272,                 /* DISPLAY  */
    DO = 273,                      /* DO  */
    DOWNCASE = 274,                /* DOWNCASE  */
    ELSE = 275,                    /* ELSE  */
    ELSEIF = 276,                  /* ELSEIF  */
    ENDCASE = 277,                 /* ENDCASE  */
    ENDIF = 278,                   /* ENDIF  */
    ENDWHILE = 279,                /* ENDWHILE  */
    EXEC = 280,                    /* EXEC  */
    EXECPORT = 281,                /* EXECPORT  */
    EXIT = 282,                    /* EXIT  */
    FIELDS = 283,                  /* FIELDS  */
    GET = 284,                     /* GET  */
    GETENV = 285,                  /* GETENV  */
    IF = 286,                      /* IF  */
    INPUTPORT = 287,               /* INPUTPORT  */
    LANY = 288,                    /* LANY  */
    LBREAK = 289,                  /* LBREAK  */
    LSPAN = 290,                   /* LSPAN  */
    MATCH = 291,                   /* MATCH  */
    NOOP = 292,                    /* NOOP  */
    NOT = 293,                     /* NOT  */
    OUTPUTPORT = 294,              /* OUTPUTPORT  */
    PRINT = 295,                   /* PRINT  */
    PROTECT = 296,                 /* PROTECT  */
    VERBATIM = 297,                /* VERBATIM  */
    PUT = 298,                     /* PUT  */
    RANY = 299,                    /* RANY  */
    RBREAK = 300,                  /* RBREAK  */
    RSPAN = 301,                   /* RSPAN  */
    SET = 302,                     /* SET  */
    SUBSTITUTE = 303,              /* SUBSTITUTE  */
    THEN = 304,                    /* THEN  */
    UPCASE = 305,                  /* UPCASE  */
    WHILE = 306,                   /* WHILE  */
    ZVAR = 307,                    /* ZVAR  */
    STYLESTRIP = 308,              /* STYLESTRIP  */
    EQ = 309,                      /* EQ  */
    NEQ = 310,                     /* NEQ  */
    REGEQ = 311,                   /* REGEQ  */
    REGNEQ = 312                   /* REGNEQ  */
  };
  typedef enum yytokentype yytoken_kind_t;
#endif
/* Token kinds.  */
#define YYEMPTY -2
#define YYEOF 0
#define YYerror 256
#define YYUNDEF 257
#define ERROR 258
#define VARNAME 259
#define VARREF 260
#define STRING 261
#define SHOW 262
#define APPENDPORT 263
#define BUFFER 264
#define BREAK 265
#define CLOSEINPUT 266
#define CLOSEOUTPUT 267
#define CLOSEPORT 268
#define CASE 269
#define CLEARBUF 270
#define DEFAULT 271
#define DISPLAY 272
#define DO 273
#define DOWNCASE 274
#define ELSE 275
#define ELSEIF 276
#define ENDCASE 277
#define ENDIF 278
#define ENDWHILE 279
#define EXEC 280
#define EXECPORT 281
#define EXIT 282
#define FIELDS 283
#define GET 284
#define GETENV 285
#define IF 286
#define INPUTPORT 287
#define LANY 288
#define LBREAK 289
#define LSPAN 290
#define MATCH 291
#define NOOP 292
#define NOT 293
#define OUTPUTPORT 294
#define PRINT 295
#define PROTECT 296
#define VERBATIM 297
#define PUT 298
#define RANY 299
#define RBREAK 300
#define RSPAN 301
#define SET 302
#define SUBSTITUTE 303
#define THEN 304
#define UPCASE 305
#define WHILE 306
#define ZVAR 307
#define STYLESTRIP 308
#define EQ 309
#define NEQ 310
#define REGEQ 311
#define REGNEQ 312

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
union YYSTYPE
{
#line 45 "./parser.y"

    char *text;
    struct _Node *node;

#line 287 "y.tab.c"

};
typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;

int yyparse (void);

#endif /* !YY_YY_Y_TAB_H_INCLUDED  */
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_ERROR = 3,                      /* ERROR  */
  YYSYMBOL_VARNAME = 4,                    /* VARNAME  */
  YYSYMBOL_VARREF = 5,                     /* VARREF  */
  YYSYMBOL_STRING = 6,                     /* STRING  */
  YYSYMBOL_SHOW = 7,                       /* SHOW  */
  YYSYMBOL_APPENDPORT = 8,                 /* APPENDPORT  */
  YYSYMBOL_BUFFER = 9,                     /* BUFFER  */
  YYSYMBOL_BREAK = 10,                     /* BREAK  */
  YYSYMBOL_CLOSEINPUT = 11,                /* CLOSEINPUT  */
  YYSYMBOL_CLOSEOUTPUT = 12,               /* CLOSEOUTPUT  */
  YYSYMBOL_CLOSEPORT = 13,                 /* CLOSEPORT  */
  YYSYMBOL_CASE = 14,                      /* CASE  */
  YYSYMBOL_CLEARBUF = 15,                  /* CLEARBUF  */
  YYSYMBOL_DEFAULT = 16,                   /* DEFAULT  */
  YYSYMBOL_DISPLAY = 17,                   /* DISPLAY  */
  YYSYMBOL_DO = 18,                        /* DO  */
  YYSYMBOL_DOWNCASE = 19,                  /* DOWNCASE  */
  YYSYMBOL_ELSE = 20,                      /* ELSE  */
  YYSYMBOL_ELSEIF = 21,                    /* ELSEIF  */
  YYSYMBOL_ENDCASE = 22,                   /* ENDCASE  */
  YYSYMBOL_ENDIF = 23,                     /* ENDIF  */
  YYSYMBOL_ENDWHILE = 24,                  /* ENDWHILE  */
  YYSYMBOL_EXEC = 25,                      /* EXEC  */
  YYSYMBOL_EXECPORT = 26,                  /* EXECPORT  */
  YYSYMBOL_EXIT = 27,                      /* EXIT  */
  YYSYMBOL_FIELDS = 28,                    /* FIELDS  */
  YYSYMBOL_GET = 29,                       /* GET  */
  YYSYMBOL_GETENV = 30,                    /* GETENV  */
  YYSYMBOL_IF = 31,                        /* IF  */
  YYSYMBOL_INPUTPORT = 32,                 /* INPUTPORT  */
  YYSYMBOL_LANY = 33,                      /* LANY  */
  YYSYMBOL_LBREAK = 34,                    /* LBREAK  */
  YYSYMBOL_LSPAN = 35,                     /* LSPAN  */
  YYSYMBOL_MATCH = 36,                     /* MATCH  */
  YYSYMBOL_NOOP = 37,                      /* NOOP  */
  YYSYMBOL_NOT = 38,                       /* NOT  */
  YYSYMBOL_OUTPUTPORT = 39,                /* OUTPUTPORT  */
  YYSYMBOL_PRINT = 40,                     /* PRINT  */
  YYSYMBOL_PROTECT = 41,                   /* PROTECT  */
  YYSYMBOL_VERBATIM = 42,                  /* VERBATIM  */
  YYSYMBOL_PUT = 43,                       /* PUT  */
  YYSYMBOL_RANY = 44,                      /* RANY  */
  YYSYMBOL_RBREAK = 45,                    /* RBREAK  */
  YYSYMBOL_RSPAN = 46,                     /* RSPAN  */
  YYSYMBOL_SET = 47,                       /* SET  */
  YYSYMBOL_SUBSTITUTE = 48,                /* SUBSTITUTE  */
  YYSYMBOL_THEN = 49,                      /* THEN  */
  YYSYMBOL_UPCASE = 50,                    /* UPCASE  */
  YYSYMBOL_WHILE = 51,                     /* WHILE  */
  YYSYMBOL_ZVAR = 52,                      /* ZVAR  */
  YYSYMBOL_STYLESTRIP = 53,                /* STYLESTRIP  */
  YYSYMBOL_54_ = 54,                       /* '|'  */
  YYSYMBOL_55_ = 55,                       /* '&'  */
  YYSYMBOL_EQ = 56,                        /* EQ  */
  YYSYMBOL_NEQ = 57,                       /* NEQ  */
  YYSYMBOL_REGEQ = 58,                     /* REGEQ  */
  YYSYMBOL_REGNEQ = 59,                    /* REGNEQ  */
  YYSYMBOL_60_ = 60,                       /* '+'  */
  YYSYMBOL_61_ = 61,                       /* '!'  */
  YYSYMBOL_62_ = 62,                       /* '('  */
  YYSYMBOL_63_ = 63,                       /* ')'  */
  YYSYMBOL_64_ = 64,                       /* ','  */
  YYSYMBOL_65_ = 65,                       /* '='  */
  YYSYMBOL_YYACCEPT = 66,                  /* $accept  */
  YYSYMBOL_program = 67,                   /* program  */
  YYSYMBOL_varname = 68,                   /* varname  */
  YYSYMBOL_string = 69,                    /* string  */
  YYSYMBOL_expr = 70,                      /* expr  */
  YYSYMBOL_statement = 71,                 /* statement  */
  YYSYMBOL_elseparts = 72,                 /* elseparts  */
  YYSYMBOL_elseifparts = 73,               /* elseifparts  */
  YYSYMBOL_match = 74,                     /* match  */
  YYSYMBOL_exprlist = 75,                  /* exprlist  */
  YYSYMBOL_comma_exprlist = 76,            /* comma_exprlist  */
  YYSYMBOL_varnamelist = 77,               /* varnamelist  */
  YYSYMBOL_matchlist = 78,                 /* matchlist  */
  YYSYMBOL_statements = 79                 /* statements  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_uint8 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   521

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  66
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  14
/* YYNRULES -- Number of rules.  */
#define YYNRULES  68
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  174

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   312


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    61,     2,     2,     2,     2,    55,     2,
      62,    63,     2,    60,    64,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    65,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,    54,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    56,
      57,    58,    59
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,    78,    78,    83,    87,    91,    94,    96,    99,   102,
     104,   106,   108,   110,   112,   114,   117,   120,   122,   124,
     126,   128,   130,   132,   134,   136,   139,   141,   143,   145,
     147,   149,   153,   155,   157,   164,   167,   172,   178,   180,
     183,   185,   187,   190,   192,   194,   196,   202,   209,   214,
     217,   220,   222,   226,   228,   237,   238,   244,   248,   264,
     265,   270,   272,   278,   279,   285,   286,   292,   293
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "ERROR", "VARNAME",
  "VARREF", "STRING", "SHOW", "APPENDPORT", "BUFFER", "BREAK",
  "CLOSEINPUT", "CLOSEOUTPUT", "CLOSEPORT", "CASE", "CLEARBUF", "DEFAULT",
  "DISPLAY", "DO", "DOWNCASE", "ELSE", "ELSEIF", "ENDCASE", "ENDIF",
  "ENDWHILE", "EXEC", "EXECPORT", "EXIT", "FIELDS", "GET", "GETENV", "IF",
  "INPUTPORT", "LANY", "LBREAK", "LSPAN", "MATCH", "NOOP", "NOT",
  "OUTPUTPORT", "PRINT", "PROTECT", "VERBATIM", "PUT", "RANY", "RBREAK",
  "RSPAN", "SET", "SUBSTITUTE", "THEN", "UPCASE", "WHILE", "ZVAR",
  "STYLESTRIP", "'|'", "'&'", "EQ", "NEQ", "REGEQ", "REGNEQ", "'+'", "'!'",
  "'('", "')'", "','", "'='", "$accept", "program", "varname", "string",
  "expr", "statement", "elseparts", "elseifparts", "match", "exprlist",
  "comma_exprlist", "varnamelist", "matchlist", "statements", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_int16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   124,    38,   309,   310,   311,   312,
      43,    33,    40,    41,    44,    61
};
#endif

#define YYPACT_NINF (-76)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-1)

#define yytable_value_is_error(Yyn) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     -76,     1,   288,   -76,   -76,   190,   -76,   190,   190,   190,
     190,   -76,   190,   190,   -76,   -76,   190,   190,   -76,   190,
     -76,   190,     6,   190,   -76,   -76,   -76,   -41,   -40,   -38,
     -36,   -35,   -34,   -25,   -22,   -20,   -19,   -18,   -16,   -13,
      20,    21,    22,   190,   190,   -76,   132,   208,   208,   208,
     208,   208,   132,     6,   -24,   132,   132,   190,   208,   -76,
      29,    56,    32,   190,   190,   190,   190,   190,   190,   190,
     190,   190,   190,   190,   190,   190,   190,   190,   -76,   308,
     190,   190,   190,   190,   190,   190,   190,   208,    -7,   190,
     208,   -76,   -76,   208,   208,   208,   190,   190,   -76,   -76,
     318,   328,   338,    68,    88,   146,   348,   358,   157,   286,
     297,   368,   378,   388,   398,   -76,    -3,    31,    25,    25,
      25,    25,   -76,   -76,   -76,   190,   -76,   190,   288,   208,
     246,   -76,   -76,   -76,   190,   190,   190,   -76,   -76,   190,
     190,   190,   -76,   -76,   -76,   -76,   288,   208,    41,    73,
      -1,   -76,   408,   418,   428,   438,   448,   458,   190,   288,
     -76,   -76,   190,   -76,   -76,   -76,   -76,   -76,   -76,   208,
     288,    44,   -76,   288
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_int8 yydefact[] =
{
      67,     0,     2,     1,    36,     0,    51,     0,     0,     0,
       0,    37,     0,     0,    52,    63,     0,     0,    32,     0,
      59,    43,     0,     0,    68,     7,     4,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     6,     0,    44,    45,    46,
      65,    59,     0,    34,     0,     0,     0,    35,    59,     3,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     8,     0,
       0,     0,     0,     0,     0,     0,     0,    38,     0,    47,
      59,    64,    67,    40,    41,    60,    42,     0,    67,    16,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     5,    10,    11,    12,    13,
      14,    15,     9,    67,    49,     0,    66,    39,    55,    33,
       0,    22,    24,    20,     0,     0,     0,    18,    19,     0,
       0,     0,    17,    21,    23,    25,    58,    61,    67,     0,
      53,    50,     0,     0,     0,     0,     0,     0,     0,    57,
      48,    67,     0,    26,    28,    30,    27,    29,    31,    62,
      54,     0,    67,    56
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
     -76,   -76,    53,   -76,    -5,   -76,   -76,   -76,   -76,   -45,
     -76,   -76,   -76,   -75
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     1,    60,    45,    95,    24,   149,   150,   126,    57,
     148,    53,    88,     2
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_uint8 yytable[] =
{
      46,     3,    47,    48,    49,    50,    89,    51,    52,   123,
      59,    54,    55,    96,    56,   124,    58,   128,    61,   161,
     162,    62,    63,   130,    64,    92,    65,    66,    67,   125,
      80,    81,    82,    83,    84,    85,    86,    68,    78,    79,
      69,    87,    70,    71,    72,   127,    73,    90,   146,    74,
      93,    94,    81,    82,    83,    84,    85,    86,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   159,    98,   116,   117,   118,   119,   120,
     121,   122,    75,    76,    77,    86,   170,    82,    83,    84,
      85,    86,   129,   172,    97,    99,   160,   173,    80,    81,
      82,    83,    84,    85,    86,   158,    91,     0,     0,     0,
      80,    81,    82,    83,    84,    85,    86,     0,     0,     0,
     147,     0,    80,    81,    82,    83,    84,    85,    86,   152,
     153,   154,   134,     0,   155,   156,   157,    25,    26,     0,
       0,    27,    80,    81,    82,    83,    84,    85,    86,     0,
       0,    28,   135,   169,     0,     0,     0,   171,     0,     0,
       0,    29,    30,     0,     0,    31,    32,    33,     0,     0,
       0,     0,     0,    34,    35,     0,    36,    37,    38,     0,
      39,     0,    40,     0,    41,    42,    80,    81,    82,    83,
      84,    85,    86,    43,    44,    25,    26,     0,     0,    27,
      80,    81,    82,    83,    84,    85,    86,     0,     0,    28,
     136,    80,    81,    82,    83,    84,    85,    86,     0,    29,
      30,   139,     0,    31,    32,    33,     0,     0,     0,     0,
       0,    34,    35,     0,    36,    37,    38,     0,    39,     0,
      40,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,    43,    44,     4,     5,     0,     6,     7,     8,     9,
      10,    11,    80,    81,    82,    83,    84,    85,    86,     0,
     151,    12,    13,    14,    15,     0,     0,    16,    17,     0,
       0,     0,     0,    18,     0,    19,    20,     0,     0,    21,
       0,     0,     0,    22,     0,     4,     5,    23,     6,     7,
       8,     9,    10,    11,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    12,    13,    14,    15,     0,     0,    16,
      17,     0,     0,     0,     0,    18,     0,    19,    20,     0,
       0,    21,     0,     0,     0,    22,     0,     0,     0,    23,
      80,    81,    82,    83,    84,    85,    86,     0,     0,     0,
     140,    80,    81,    82,    83,    84,    85,    86,     0,     0,
       0,   141,    80,    81,    82,    83,    84,    85,    86,     0,
       0,   115,    80,    81,    82,    83,    84,    85,    86,     0,
       0,   131,    80,    81,    82,    83,    84,    85,    86,     0,
       0,   132,    80,    81,    82,    83,    84,    85,    86,     0,
       0,   133,    80,    81,    82,    83,    84,    85,    86,     0,
       0,   137,    80,    81,    82,    83,    84,    85,    86,     0,
       0,   138,    80,    81,    82,    83,    84,    85,    86,     0,
       0,   142,    80,    81,    82,    83,    84,    85,    86,     0,
       0,   143,    80,    81,    82,    83,    84,    85,    86,     0,
       0,   144,    80,    81,    82,    83,    84,    85,    86,     0,
       0,   145,    80,    81,    82,    83,    84,    85,    86,     0,
       0,   163,    80,    81,    82,    83,    84,    85,    86,     0,
       0,   164,    80,    81,    82,    83,    84,    85,    86,     0,
       0,   165,    80,    81,    82,    83,    84,    85,    86,     0,
       0,   166,    80,    81,    82,    83,    84,    85,    86,     0,
       0,   167,    80,    81,    82,    83,    84,    85,    86,     0,
       0,   168
};

static const yytype_int16 yycheck[] =
{
       5,     0,     7,     8,     9,    10,    51,    12,    13,    16,
       4,    16,    17,    58,    19,    22,    21,    92,    23,    20,
      21,    62,    62,    98,    62,    49,    62,    62,    62,    36,
      54,    55,    56,    57,    58,    59,    60,    62,    43,    44,
      62,    46,    62,    62,    62,    90,    62,    52,   123,    62,
      55,    56,    55,    56,    57,    58,    59,    60,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,   148,    18,    80,    81,    82,    83,    84,
      85,    86,    62,    62,    62,    60,   161,    56,    57,    58,
      59,    60,    97,    49,    65,    63,    23,   172,    54,    55,
      56,    57,    58,    59,    60,    64,    53,    -1,    -1,    -1,
      54,    55,    56,    57,    58,    59,    60,    -1,    -1,    -1,
     125,    -1,    54,    55,    56,    57,    58,    59,    60,   134,
     135,   136,    64,    -1,   139,   140,   141,     5,     6,    -1,
      -1,     9,    54,    55,    56,    57,    58,    59,    60,    -1,
      -1,    19,    64,   158,    -1,    -1,    -1,   162,    -1,    -1,
      -1,    29,    30,    -1,    -1,    33,    34,    35,    -1,    -1,
      -1,    -1,    -1,    41,    42,    -1,    44,    45,    46,    -1,
      48,    -1,    50,    -1,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,     5,     6,    -1,    -1,     9,
      54,    55,    56,    57,    58,    59,    60,    -1,    -1,    19,
      64,    54,    55,    56,    57,    58,    59,    60,    -1,    29,
      30,    64,    -1,    33,    34,    35,    -1,    -1,    -1,    -1,
      -1,    41,    42,    -1,    44,    45,    46,    -1,    48,    -1,
      50,    -1,    52,    53,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    61,    62,     7,     8,    -1,    10,    11,    12,    13,
      14,    15,    54,    55,    56,    57,    58,    59,    60,    -1,
      24,    25,    26,    27,    28,    -1,    -1,    31,    32,    -1,
      -1,    -1,    -1,    37,    -1,    39,    40,    -1,    -1,    43,
      -1,    -1,    -1,    47,    -1,     7,     8,    51,    10,    11,
      12,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    25,    26,    27,    28,    -1,    -1,    31,
      32,    -1,    -1,    -1,    -1,    37,    -1,    39,    40,    -1,
      -1,    43,    -1,    -1,    -1,    47,    -1,    -1,    -1,    51,
      54,    55,    56,    57,    58,    59,    60,    -1,    -1,    -1,
      64,    54,    55,    56,    57,    58,    59,    60,    -1,    -1,
      -1,    64,    54,    55,    56,    57,    58,    59,    60,    -1,
      -1,    63,    54,    55,    56,    57,    58,    59,    60,    -1,
      -1,    63,    54,    55,    56,    57,    58,    59,    60,    -1,
      -1,    63,    54,    55,    56,    57,    58,    59,    60,    -1,
      -1,    63,    54,    55,    56,    57,    58,    59,    60,    -1,
      -1,    63,    54,    55,    56,    57,    58,    59,    60,    -1,
      -1,    63,    54,    55,    56,    57,    58,    59,    60,    -1,
      -1,    63,    54,    55,    56,    57,    58,    59,    60,    -1,
      -1,    63,    54,    55,    56,    57,    58,    59,    60,    -1,
      -1,    63,    54,    55,    56,    57,    58,    59,    60,    -1,
      -1,    63,    54,    55,    56,    57,    58,    59,    60,    -1,
      -1,    63,    54,    55,    56,    57,    58,    59,    60,    -1,
      -1,    63,    54,    55,    56,    57,    58,    59,    60,    -1,
      -1,    63,    54,    55,    56,    57,    58,    59,    60,    -1,
      -1,    63,    54,    55,    56,    57,    58,    59,    60,    -1,
      -1,    63,    54,    55,    56,    57,    58,    59,    60,    -1,
      -1,    63
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_int8 yystos[] =
{
       0,    67,    79,     0,     7,     8,    10,    11,    12,    13,
      14,    15,    25,    26,    27,    28,    31,    32,    37,    39,
      40,    43,    47,    51,    71,     5,     6,     9,    19,    29,
      30,    33,    34,    35,    41,    42,    44,    45,    46,    48,
      50,    52,    53,    61,    62,    69,    70,    70,    70,    70,
      70,    70,    70,    77,    70,    70,    70,    75,    70,     4,
      68,    70,    62,    62,    62,    62,    62,    62,    62,    62,
      62,    62,    62,    62,    62,    62,    62,    62,    70,    70,
      54,    55,    56,    57,    58,    59,    60,    70,    78,    75,
      70,    68,    49,    70,    70,    70,    75,    65,    18,    63,
      70,    70,    70,    70,    70,    70,    70,    70,    70,    70,
      70,    70,    70,    70,    70,    63,    70,    70,    70,    70,
      70,    70,    70,    16,    22,    36,    74,    75,    79,    70,
      79,    63,    63,    63,    64,    64,    64,    63,    63,    64,
      64,    64,    63,    63,    63,    63,    79,    70,    76,    72,
      73,    24,    70,    70,    70,    70,    70,    70,    64,    79,
      23,    20,    21,    63,    63,    63,    63,    63,    63,    70,
      79,    70,    49,    79
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_int8 yyr1[] =
{
       0,    66,    67,    68,    69,    70,    70,    70,    70,    70,
      70,    70,    70,    70,    70,    70,    70,    70,    70,    70,
      70,    70,    70,    70,    70,    70,    70,    70,    70,    70,
      70,    70,    71,    71,    71,    71,    71,    71,    71,    71,
      71,    71,    71,    71,    71,    71,    71,    71,    71,    71,
      71,    71,    71,    72,    72,    73,    73,    74,    74,    75,
      75,    76,    76,    77,    77,    78,    78,    79,    79
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     1,     1,     1,     3,     1,     1,     2,     3,
       3,     3,     3,     3,     3,     3,     3,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     6,     6,     6,     6,
       6,     6,     1,     4,     2,     2,     1,     1,     3,     4,
       3,     3,     3,     1,     2,     2,     2,     3,     6,     4,
       5,     1,     1,     1,     3,     0,     5,     3,     2,     0,
       2,     1,     3,     0,     2,     0,     2,     0,     2
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
# ifndef YY_LOCATION_PRINT
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YYUSE (yyoutput);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yykind < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yykind], *yyvaluep);
# endif
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* program: statements  */
#line 79 "./parser.y"
        { the_program = reverse_list_of_nodes((yyvsp[0].node));
	  (yyval.node) = the_program; }
#line 1522 "y.tab.c"
    break;

  case 3: /* varname: VARNAME  */
#line 84 "./parser.y"
       { (yyval.node) = node_create_string_constant(VARNAME_OPCODE, (yyvsp[0].text)); }
#line 1528 "y.tab.c"
    break;

  case 4: /* string: STRING  */
#line 88 "./parser.y"
       { (yyval.node) = node_create_string_constant(STRING_CONSTANT_OPCODE, (yyvsp[0].text)); }
#line 1534 "y.tab.c"
    break;

  case 5: /* expr: '(' expr ')'  */
#line 92 "./parser.y"
        { (yyval.node) = (yyvsp[-1].node); }
#line 1540 "y.tab.c"
    break;

  case 6: /* expr: string  */
#line 95 "./parser.y"
        { (yyval.node) = (yyvsp[0].node); }
#line 1546 "y.tab.c"
    break;

  case 7: /* expr: VARREF  */
#line 97 "./parser.y"
       { (yyval.node) = node_create_string_constant(VARREF_OPCODE, (yyvsp[0].text)); }
#line 1552 "y.tab.c"
    break;

  case 8: /* expr: '!' expr  */
#line 100 "./parser.y"
        { (yyval.node) = node_create_unary(NOT_OPCODE, (yyvsp[0].node)); }
#line 1558 "y.tab.c"
    break;

  case 9: /* expr: expr '+' expr  */
#line 103 "./parser.y"
        { (yyval.node) = node_create_binary(PLUS_OPCODE, (yyvsp[-2].node), (yyvsp[0].node)); }
#line 1564 "y.tab.c"
    break;

  case 10: /* expr: expr '|' expr  */
#line 105 "./parser.y"
        { (yyval.node) = node_create_binary(OR_OPCODE, (yyvsp[-2].node), (yyvsp[0].node)); }
#line 1570 "y.tab.c"
    break;

  case 11: /* expr: expr '&' expr  */
#line 107 "./parser.y"
        { (yyval.node) = node_create_binary(AND_OPCODE, (yyvsp[-2].node), (yyvsp[0].node)); }
#line 1576 "y.tab.c"
    break;

  case 12: /* expr: expr EQ expr  */
#line 109 "./parser.y"
        { (yyval.node) = node_create_binary(EQ_OPCODE, (yyvsp[-2].node), (yyvsp[0].node)); }
#line 1582 "y.tab.c"
    break;

  case 13: /* expr: expr NEQ expr  */
#line 111 "./parser.y"
        { (yyval.node) = node_create_binary(NEQ_OPCODE, (yyvsp[-2].node), (yyvsp[0].node)); }
#line 1588 "y.tab.c"
    break;

  case 14: /* expr: expr REGEQ expr  */
#line 113 "./parser.y"
        { (yyval.node) = node_create_binary(REGEQ_OPCODE, (yyvsp[-2].node), (yyvsp[0].node)); }
#line 1594 "y.tab.c"
    break;

  case 15: /* expr: expr REGNEQ expr  */
#line 115 "./parser.y"
        { (yyval.node) = node_create_binary(REGNEQ_OPCODE, (yyvsp[-2].node), (yyvsp[0].node)); }
#line 1600 "y.tab.c"
    break;

  case 16: /* expr: BUFFER '(' ')'  */
#line 118 "./parser.y"
        { (yyval.node) = node_create_noary(BUFFER_OPCODE); }
#line 1606 "y.tab.c"
    break;

  case 17: /* expr: SUBSTITUTE '(' expr ')'  */
#line 121 "./parser.y"
        { (yyval.node) = node_create_unary(SUBSTITUTE_OPCODE, (yyvsp[-1].node)); }
#line 1612 "y.tab.c"
    break;

  case 18: /* expr: PROTECT '(' expr ')'  */
#line 123 "./parser.y"
        { (yyval.node) = node_create_unary(PROTECT_OPCODE, (yyvsp[-1].node)); }
#line 1618 "y.tab.c"
    break;

  case 19: /* expr: VERBATIM '(' expr ')'  */
#line 125 "./parser.y"
        { (yyval.node) = node_create_unary(VERBATIM_OPCODE, (yyvsp[-1].node)); }
#line 1624 "y.tab.c"
    break;

  case 20: /* expr: GETENV '(' expr ')'  */
#line 127 "./parser.y"
        { (yyval.node) = node_create_unary(GETENV_OPCODE, (yyvsp[-1].node)); }
#line 1630 "y.tab.c"
    break;

  case 21: /* expr: UPCASE '(' expr ')'  */
#line 129 "./parser.y"
        { (yyval.node) = node_create_unary(UPCASE_OPCODE, (yyvsp[-1].node)); }
#line 1636 "y.tab.c"
    break;

  case 22: /* expr: DOWNCASE '(' expr ')'  */
#line 131 "./parser.y"
        { (yyval.node) = node_create_unary(DOWNCASE_OPCODE, (yyvsp[-1].node)); }
#line 1642 "y.tab.c"
    break;

  case 23: /* expr: ZVAR '(' expr ')'  */
#line 133 "./parser.y"
        { (yyval.node) = node_create_unary(ZVAR_OPCODE, (yyvsp[-1].node)); }
#line 1648 "y.tab.c"
    break;

  case 24: /* expr: GET '(' expr ')'  */
#line 135 "./parser.y"
        { (yyval.node) = node_create_unary(GET_OPCODE, (yyvsp[-1].node)); }
#line 1654 "y.tab.c"
    break;

  case 25: /* expr: STYLESTRIP '(' expr ')'  */
#line 137 "./parser.y"
        { (yyval.node) = node_create_unary(STYLESTRIP_OPCODE, (yyvsp[-1].node)); }
#line 1660 "y.tab.c"
    break;

  case 26: /* expr: LANY '(' expr ',' expr ')'  */
#line 140 "./parser.y"
        { (yyval.node) = node_create_binary(LANY_OPCODE, (yyvsp[-3].node), (yyvsp[-1].node) ); }
#line 1666 "y.tab.c"
    break;

  case 27: /* expr: RANY '(' expr ',' expr ')'  */
#line 142 "./parser.y"
        { (yyval.node) = node_create_binary(RANY_OPCODE, (yyvsp[-3].node), (yyvsp[-1].node) ); }
#line 1672 "y.tab.c"
    break;

  case 28: /* expr: LBREAK '(' expr ',' expr ')'  */
#line 144 "./parser.y"
        { (yyval.node) = node_create_binary(LBREAK_OPCODE, (yyvsp[-3].node), (yyvsp[-1].node) ); }
#line 1678 "y.tab.c"
    break;

  case 29: /* expr: RBREAK '(' expr ',' expr ')'  */
#line 146 "./parser.y"
        { (yyval.node) = node_create_binary(RBREAK_OPCODE, (yyvsp[-3].node), (yyvsp[-1].node) ); }
#line 1684 "y.tab.c"
    break;

  case 30: /* expr: LSPAN '(' expr ',' expr ')'  */
#line 148 "./parser.y"
        { (yyval.node) = node_create_binary(LSPAN_OPCODE, (yyvsp[-3].node), (yyvsp[-1].node) ); }
#line 1690 "y.tab.c"
    break;

  case 31: /* expr: RSPAN '(' expr ',' expr ')'  */
#line 150 "./parser.y"
        { (yyval.node) = node_create_binary(RSPAN_OPCODE, (yyvsp[-3].node), (yyvsp[-1].node) ); }
#line 1696 "y.tab.c"
    break;

  case 32: /* statement: NOOP  */
#line 154 "./parser.y"
              { (yyval.node) = node_create_noary(NOOP_OPCODE); }
#line 1702 "y.tab.c"
    break;

  case 33: /* statement: SET varname '=' expr  */
#line 156 "./parser.y"
              { (yyval.node) = node_create_binary(SET_OPCODE, (yyvsp[-2].node), (yyvsp[0].node)); }
#line 1708 "y.tab.c"
    break;

  case 34: /* statement: FIELDS varnamelist  */
#line 158 "./parser.y"
              { (yyval.node) = node_create_unary(FIELDS_OPCODE,
				       reverse_list_of_nodes((yyvsp[0].node))); }
#line 1715 "y.tab.c"
    break;

  case 35: /* statement: PRINT exprlist  */
#line 165 "./parser.y"
              { (yyval.node) = node_create_unary(PRINT_OPCODE,
				       reverse_list_of_nodes((yyvsp[0].node))); }
#line 1722 "y.tab.c"
    break;

  case 36: /* statement: SHOW  */
#line 168 "./parser.y"
              { (yyval.node) = node_create_unary(PRINT_OPCODE,
		       node_create_unary(SUBSTITUTE_OPCODE,
			 node_create_string_constant(STRING_CONSTANT_OPCODE,
						     (yyvsp[0].text)))); }
#line 1731 "y.tab.c"
    break;

  case 37: /* statement: CLEARBUF  */
#line 173 "./parser.y"
              { (yyval.node) = node_create_noary(CLEARBUF_OPCODE); }
#line 1737 "y.tab.c"
    break;

  case 38: /* statement: APPENDPORT expr expr  */
#line 179 "./parser.y"
              { (yyval.node) = node_create_binary(APPENDPORT_OPCODE, (yyvsp[-1].node), (yyvsp[0].node)); }
#line 1743 "y.tab.c"
    break;

  case 39: /* statement: EXECPORT expr expr exprlist  */
#line 181 "./parser.y"
              { (yyvsp[-1].node)->next = reverse_list_of_nodes((yyvsp[0].node));
		(yyval.node) = node_create_binary(EXECPORT_OPCODE, (yyvsp[-2].node), (yyvsp[-1].node)); }
#line 1750 "y.tab.c"
    break;

  case 40: /* statement: INPUTPORT expr expr  */
#line 184 "./parser.y"
              { (yyval.node) = node_create_binary(INPUTPORT_OPCODE, (yyvsp[-1].node), (yyvsp[0].node)); }
#line 1756 "y.tab.c"
    break;

  case 41: /* statement: OUTPUTPORT expr expr  */
#line 186 "./parser.y"
              { (yyval.node) = node_create_binary(OUTPUTPORT_OPCODE, (yyvsp[-1].node), (yyvsp[0].node)); }
#line 1762 "y.tab.c"
    break;

  case 42: /* statement: PUT expr exprlist  */
#line 188 "./parser.y"
              { (yyval.node) = node_create_binary(PUT_OPCODE, (yyvsp[-1].node),
					reverse_list_of_nodes((yyvsp[0].node))); }
#line 1769 "y.tab.c"
    break;

  case 43: /* statement: PUT  */
#line 191 "./parser.y"
              { (yyval.node) = node_create_binary(PUT_OPCODE, 0, 0); }
#line 1775 "y.tab.c"
    break;

  case 44: /* statement: CLOSEINPUT expr  */
#line 193 "./parser.y"
              { (yyval.node) = node_create_unary(CLOSEINPUT_OPCODE, (yyvsp[0].node)); }
#line 1781 "y.tab.c"
    break;

  case 45: /* statement: CLOSEOUTPUT expr  */
#line 195 "./parser.y"
              { (yyval.node) = node_create_unary(CLOSEOUTPUT_OPCODE, (yyvsp[0].node)); }
#line 1787 "y.tab.c"
    break;

  case 46: /* statement: CLOSEPORT expr  */
#line 197 "./parser.y"
              { (yyval.node) = node_create_unary(CLOSEPORT_OPCODE, (yyvsp[0].node)); }
#line 1793 "y.tab.c"
    break;

  case 47: /* statement: EXEC expr exprlist  */
#line 203 "./parser.y"
              { (yyvsp[-1].node)->next = reverse_list_of_nodes((yyvsp[0].node));
		(yyval.node) = node_create_unary(EXEC_OPCODE, (yyvsp[-1].node)); }
#line 1800 "y.tab.c"
    break;

  case 48: /* statement: IF expr THEN statements elseparts ENDIF  */
#line 210 "./parser.y"
              { Node *n = node_create_binary(IF_OPCODE, (yyvsp[-4].node),
					     reverse_list_of_nodes((yyvsp[-2].node)));
		n->next = (yyvsp[-1].node);
		(yyval.node) = node_create_unary(IF_STMT_OPCODE, n); }
#line 1809 "y.tab.c"
    break;

  case 49: /* statement: CASE expr matchlist ENDCASE  */
#line 215 "./parser.y"
              { (yyval.node) = node_create_binary(CASE_OPCODE, (yyvsp[-2].node),
					reverse_list_of_nodes((yyvsp[-1].node))); }
#line 1816 "y.tab.c"
    break;

  case 50: /* statement: WHILE expr DO statements ENDWHILE  */
#line 218 "./parser.y"
              { (yyval.node) = node_create_binary(WHILE_OPCODE, (yyvsp[-3].node),
					reverse_list_of_nodes((yyvsp[-1].node))); }
#line 1823 "y.tab.c"
    break;

  case 51: /* statement: BREAK  */
#line 221 "./parser.y"
              { (yyval.node) = node_create_noary(BREAK_OPCODE); }
#line 1829 "y.tab.c"
    break;

  case 52: /* statement: EXIT  */
#line 223 "./parser.y"
              { (yyval.node) = node_create_noary(EXIT_OPCODE); }
#line 1835 "y.tab.c"
    break;

  case 53: /* elseparts: elseifparts  */
#line 227 "./parser.y"
                { (yyval.node) = reverse_list_of_nodes((yyvsp[0].node)); }
#line 1841 "y.tab.c"
    break;

  case 54: /* elseparts: elseifparts ELSE statements  */
#line 229 "./parser.y"
                { (yyval.node) = node_create_binary(ELSE_OPCODE, 0,
					  reverse_list_of_nodes((yyvsp[0].node)));
		  (yyval.node)->next = (yyvsp[-2].node);
	          (yyval.node) = reverse_list_of_nodes((yyval.node)); }
#line 1850 "y.tab.c"
    break;

  case 55: /* elseifparts: %empty  */
#line 237 "./parser.y"
                { (yyval.node) = 0; }
#line 1856 "y.tab.c"
    break;

  case 56: /* elseifparts: elseifparts ELSEIF expr THEN statements  */
#line 239 "./parser.y"
                { (yyval.node) = node_create_binary(ELSEIF_OPCODE, (yyvsp[-2].node),
					  reverse_list_of_nodes((yyvsp[0].node)));
		  (yyval.node)->next = (yyvsp[-4].node); }
#line 1864 "y.tab.c"
    break;

  case 57: /* match: MATCH comma_exprlist statements  */
#line 245 "./parser.y"
                { (yyval.node) = node_create_binary(MATCHLIST_OPCODE,
					  reverse_list_of_nodes((yyvsp[-1].node)),
					  reverse_list_of_nodes((yyvsp[0].node))); }
#line 1872 "y.tab.c"
    break;

  case 58: /* match: DEFAULT statements  */
#line 249 "./parser.y"
                { (yyval.node) = node_create_binary(DEFAULT_OPCODE, 0,
					  reverse_list_of_nodes((yyvsp[0].node))); }
#line 1879 "y.tab.c"
    break;

  case 59: /* exprlist: %empty  */
#line 264 "./parser.y"
             { (yyval.node) = 0; }
#line 1885 "y.tab.c"
    break;

  case 60: /* exprlist: exprlist expr  */
#line 266 "./parser.y"
             { (yyval.node) = (yyvsp[0].node);
	       (yyval.node)->next = (yyvsp[-1].node); }
#line 1892 "y.tab.c"
    break;

  case 61: /* comma_exprlist: expr  */
#line 271 "./parser.y"
                 { (yyval.node) = (yyvsp[0].node); }
#line 1898 "y.tab.c"
    break;

  case 62: /* comma_exprlist: comma_exprlist ',' expr  */
#line 273 "./parser.y"
                 { (yyval.node) = (yyvsp[0].node);
		   (yyval.node)->next = (yyvsp[-2].node); }
#line 1905 "y.tab.c"
    break;

  case 63: /* varnamelist: %empty  */
#line 278 "./parser.y"
             { (yyval.node) = 0; }
#line 1911 "y.tab.c"
    break;

  case 64: /* varnamelist: varnamelist varname  */
#line 280 "./parser.y"
             { (yyval.node) = (yyvsp[0].node);
	       (yyval.node)->next = (yyvsp[-1].node); }
#line 1918 "y.tab.c"
    break;

  case 65: /* matchlist: %empty  */
#line 285 "./parser.y"
                { (yyval.node) = 0; }
#line 1924 "y.tab.c"
    break;

  case 66: /* matchlist: matchlist match  */
#line 287 "./parser.y"
                { (yyval.node) = (yyvsp[0].node);
		  (yyval.node)->next = (yyvsp[-1].node); }
#line 1931 "y.tab.c"
    break;

  case 67: /* statements: %empty  */
#line 292 "./parser.y"
        { (yyval.node) = 0; }
#line 1937 "y.tab.c"
    break;

  case 68: /* statements: statements statement  */
#line 294 "./parser.y"
        { (yyval.node) = (yyvsp[0].node);
	  (yyval.node)->next = (yyvsp[-1].node); }
#line 1944 "y.tab.c"
    break;


#line 1948 "y.tab.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if !defined yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturn;
#endif


/*-------------------------------------------------------.
| yyreturn -- parsing is finished, clean up and return.  |
`-------------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 298 "./parser.y"


/*
 * error_occured - Set to true when a parse error is reported.  If it is false
 *                 at the time a parse error is reported, a message is
 *                 printed on stderr.  See report_parse_error for more
 *                 details.
 */

static int error_occured = 0;

/*
 *  Parser-Lexer Internal Routine:
 *
 *    void report_parse_error(char *error_message, int line_number)
 *        Modifies: error_occured, stderr
 *        Effects: This routine is called to report a parser or lexer
 *                 error.  Error_message is the error message and line_number
 *                 the line number it occured on.  The reported error message
 *                 is of the form "....<error_message> on line <line #>.\n".
 *                 This routine sets error_occured (local to parser.y) to
 *                 true.  If it was previously false, the error message
 *                 is reported to the user via stderr. 
 */

void
report_parse_error(char *error_message,
		   int line_number)
{
    if (error_occured)
      return;
    error_occured = 1;

    fprintf(stderr, "zwgc: error in description file: %s on line %d.\n",
	    error_message, line_number);
    fflush(stderr);
}

/*
 *  yyerror - internal routine - used by yacc to report syntax errors and
 *            stack overflow errors.
 */
 
static void yyerror(char *message)
{
    report_parse_error(message, yylineno);
}

/*
 *    struct _Node *parse_file(FILE *input_file)
 *        Requires: input_file is opened for reading, no pointers to
 *                  existing nodes will ever be dereferened.
 *        Modifies: *input_file, stderr, all existing nodes
 *        Effects: First this routine destroys all nodes.  Then it parses
 *                 input_file as a zwgc description langauge file.  If
 *                 an error is encountered, an error message is printed
 *                 on stderr and NULL is returned.  If no error is
 *                 encountered, a pointer to the node representation of
 *                 the parsed program is returned, suitable for passing to
 *                 exec.c.  Note that NULL will also be returned for a
 *                 empty file & is a valid program.  Either way, input_file
 *                 is closed before this routine returns.
 */

struct _Node *
parse_file(FILE *input_file)
{
    the_program = NULL;
    error_occured = 0;
    node_DestroyAllNodes();

    lex_open(input_file);
    yyparse();
    fclose(input_file);

    if (error_occured) {
	node_DestroyAllNodes();
	the_program = NULL;
    }

#ifdef DEBUG
    if (zwgc_debug) {
	printf("****************************************************************************\n");
	node_display(the_program);
	printf("****************************************************************************\n");
    }
#endif
    
    return(the_program);
}
